-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

-- 획득 알림 아이템목록
local AlertLootItemList={
    "질긴 옆구리살",
    "보랏빛 해파리",
    "무거운 반짝껍질",
    "호화로운 모피",
    -- 이하 퀘스트 관련
    "영혼의 정수",
    "피눈물 부족 혈액",
    "피눈물 횃불",
    "오염된 지옥멧돼지 고기",
    "지옥멧돼지 혈액 견본",
    "장막의 스키스 우리 열쇠",
    "파멸의 해골",
    "고대의 주화",
    "심해 명주",
--    "거대한 무턱 모래무지",
--    "거대한 화염 암모나이트",
--    "거대한 바다 전갈",
--    "거대한 검은바다 채찍꼬리",
--    "거대한 심연 풍선장어",
--    "거대한 눈먼 민물 철갑상어",
--  "단열 배선",
};

local AlertLootItem = CreateFrame("FRAME");
AlertLootItem:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function AlertLootItem:CHAT_MSG_LOOT(...)
    local ll = {...};
    --DebugPrint(ll);

    local event, msg = ...
    --print(event..":"..msg);

    -- 20191124
    -- 내케릭 아이템 획득만 처리
    -- 요거 안하면 주위타케릭 아이템 획득도 알림.
    local unitGUID = select(13, ...);
    if( UnitGUID("player") ~= unitGUID ) then
        return;
    end
    --DebugPrint({GetItemInfo(itemString)});
    --------------------------------------------------------------------------------
    -- 1단계)
    -- 아이템획득 채팅창의 메시지내용을 이용하여, 아이템링크에서 itemString 추출
    -- ex) 아이템을 획득했습니다. : [질긴 옆구리살]x5
    --  itemString    ==> item:3299::::::::20:257::::::
    --  lootItemCount ==> 5
    --
    -- 참고) ItemLink 형태
    --  ==> |cff9d9d9d|Hitem:3299::::::::20:257::::::|h[Fractured Canine]|h|r
    --------------------------------------------------------------------------------
    --local msg ="|cff9d9d9d|Hitem:3299::::::::20:257::::::|h[Fractured Canine]|h|r"
    local itemString = string.match(msg, "item[%-?%d:]+");
    local lootItemCount = string.match(msg, "x(%d+)") or 1;
    --print(lootItemCount);
    
    --------------------------------------------------------------------------------
    -- 위에서 사용한 정규식 설명
    -- 1. string.match(msg, "item[%-?%d:]+");
    -- [set]: 중괄호 안의 어떤 문자라도 맞으면 OK.(모두 or) 
    -- %-   : %x는 예약어 기능 없이 문자열 자체를 사용하겠단 의미.[예약어 ^$()%.[]*+-?]
    --        - 는 [앞문자 기준](없을수도 있고)최소 반복될때 까지 찾는 예약어(*,+,-,?),
    --        여기선 앞에 %을 붙여서 예약어가 아닌 "-" 문자를 의미.
    -- ?    : ?는 [앞문자 기준](없을수도 있고) 많이 있어도 한번만 찾는 예약어.
    --        앞문자는 "-", - 를 사용해도 같은 결과일듯, %--
    -- %d   : 숫자를 의미
    -- :    : 예약어 아님, 문자 ":"
    -- +    : + 는 [앞문자 기준](없을수도 있고)최대 반복될때 까지 찾는 예약어(*,+,-,?),
    --        여기선 앞문자가 [set]이므로, set에 포함되는 않는 문자열이 나올때까지
    --        계속해서 길어질거란 의미.
    -- 
    -- 정리) "item" + ( "-" 또는 숫자 또는 ":" )..포함되는 않는 문자열이 나올때까지.
    --       위의 예문에서 |(파이프)는 포함되지 않으니깐, 
    --       결과는 : "item:3299::::::::20:257::::::"
    -- 
    -- 진득의견) 그냥 -는 버리고, "item[%d:]+" 하면 안되나... 못찾는건 버려도 되니..
    -- 
    -- 2. string.match(msg, "x(%d+)") or 1
    -- x    : "x"
    -- %d+  : 숫자만 이어진 문자열
    -- ()   : 괄호안의 부분만 반환하겠단 의미, 괄호가 여러번 있으면 v1,v2,v3..형태반환
    --        여기선 괄호가 한개만 있으므로 반환값은 1개임.
    -- 정리) "x"+숫자 부분에서 숫자만 추출하겠단 의미.
    --       or 1 : nil이면 1반환.
    --
    -- etc.
    -- link:match('item:(%d+)')    =>   item: 이후 첫번째 숫자부분만 반환.(itemId)
    -- 
    --------------------------------------------------------------------------------

    --------------------------------------------------------------------------------
    -- 2단계)
    -- 아이템정보 조회
    -- GetItemInfo(itemString) 이용
    --------------------------------------------------------------------------------
    --local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
    --      itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
    --      isCraftingReagent = GetItemInfo(itemID or "itemString" or "itemName" or "itemLink")

    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
          itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
          isCraftingReagent = GetItemInfo(itemString);

    --------------------------------------------------------------------------------
    -- 20191123 모든 아이템 획득시마다 항상 보유갯수 출력기능 추가
    -- 챗창이 지저분해지는걸 피하기 위해 에러프레임만 출력함.
    --------------------------------------------------------------------------------
    local bCnt = GetItemCount(itemLink, nil,true);   -- 은행미포함.(2번째 인자)
    local lCnt = lootItemCount;
    local tCnt = bCnt + lootItemCount;

    local formatedString = format(L["%s %s개 보유"],itemLink, tCnt);

    --------------------------------------------
    -- 20191125 회색템이상 알림토록 함.
    --------------------------------------------
    if( itemRarity > 0 ) then
        --DebugPrint({GetItemInfo(itemString)});
        --print( "보유:"..bCnt..",획득:"..lCnt.." 전체:"..tCnt);

        -------------------------------------------------------------
        -- 1차수정,
        -- 퀘스트아이템은 가방에 누적되지 않음.
        -- Ex) 20개 획득 퀘스트인경우 계속 1개로 표현됨.
        -- "획득" 으로 알림메시지 변경
        -- 2차수정.
        -- 퀘스트아이템 중에서도 누적되는 아이템이 있었음.
        -- 퀘스트아이템 "획득"표현 안함.(걍 1개 표현함.)
        -- 3차수정(20200205)
        -- 퀘스트아이템인 경우 기본UI의 퀘스트진행상황에 갯수가 
        -- 표현됨으로 알림표현 안함.
        -------------------------------------------------------------
        --if( itemType == "퀘스트" and itemStackCount == 1 ) then
        if( itemClassID == LE_ITEM_CLASS_QUESTITEM and itemStackCount > 1 ) then
            --UIErrorsFrame     :AddMessage(""..itemLink.." "..tCnt.."|r개 획득", 0, 1, 0);    -- Green
            --DEFAULT_CHAT_FRAME:AddMessage(""..itemLink.." "..tCnt.."|r개 획득", 0, 1, 0);    -- Green
        
        else
            UIErrorsFrame     :AddMessage(formatedString, 0, 1, 0);  -- Green
            DEFAULT_CHAT_FRAME:AddMessage(formatedString, 0, 1, 0);  -- Green
        end

    end

    --------------------------------------------------------------------------------
    -- 3단계)
    -- 찾는 아이템인지 확인
    --------------------------------------------------------------------------------
    local CheckInList = false;
    --local itemID = "";
    for i=1, #AlertLootItemList do
        if itemName == AlertLootItemList[i] then
            CheckInList = true;
            break;
        end;
    end

    --------------------------------------------------------------------------------
    -- 4단계)
    -- 획득 알림.
    --------------------------------------------------------------------------------
    if CheckInList then
        --PlaySound_LootItem();
        PlaySound_Success();
        DEFAULT_CHAT_FRAME:AddMessage("\<"..L["아이템획득"].."\> "..formatedString, 1, 0, 0);    -- Red
    end

end
AlertLootItem:RegisterEvent("CHAT_MSG_LOOT");